---
title: Network Error Logging
slug: Web/HTTP/Network_Error_Logging
tags:
  - Guide
  - HTTP
  - Network Error Logging
  - Reference
---
<div>{{HTTPSidebar}}</div>

<p>{{seecompattable}}</p>

<p class="summary">Network Error Logging is a mechanism that can be configured via the {{HTTPHeader("NEL")}} HTTP <em><a href="/en-US/docs/Glossary/Response_header">response header</a></em>. This experimental header allows web sites and applications to opt-in to receive reports about failed (and, if desired, successful) network fetches from supporting browsers.</p>

<p class="summary">Reports are sent to a reporting group defined within a {{HTTPHeader("Report-To")}} header.</p>

<h2 id="Usage">Usage</h2>

<p>Web applications opt in to this behaviour with the NEL header, which is a <em><a href="/en-US/docs/Glossary/Response_header">JSON-encoded</a></em> object:</p>

<pre><a href="https://www.w3.org/TR/network-error-logging/#nel-response-header">NEL</a>: { "<a href="https://www.w3.org/TR/network-error-logging/#the-report_to-member">report_to</a>": "nel",
       "<a href="https://www.w3.org/TR/network-error-logging/#the-max_age-member">max_age</a>": 31556952 }
</pre>

<p>An origin considered secure by the browser is required.</p>

<p>The following object keys can be specified in the NEL header:</p>

<dl>
 <dt>report_to</dt>
 <dd>
 <p>The <a href="/en-US/docs/Web/API/Reporting_API">reporting API</a> group to send network error reports to (see below).</p>
 </dd>
 <dt>max_age</dt>
 <dd>Specifies the lifetime of the policy, in seconds (in a similar way to e.g. HSTS policies are time-restricted). The referenced reporting group should have a lifetime at least as long as the NEL policy.</dd>
 <dt>include_subdomains</dt>
 <dd>If true, the policy applies to all subdomains under the origin that the policy header is set. The reporting group should also be set to include subdomains, if this option is to be enabled.</dd>
 <dt>success_fraction</dt>
 <dd>Floating point value between 0 and 1 which specifies the proportion of <strong>successful</strong> network requests to report. Defaults to 0, so that no successful network requests will be reported if the key is not present in the JSON payload.</dd>
 <dt>failure_fraction</dt>
 <dd>Floating point value between 0 and 1 which specifies the proportion of <strong>failed</strong> network requests to report. Defaults to 1, so that all failed network requests will be reported if the key is not present in the JSON payload.</dd>
</dl>

<p>The reporting group referenced above is defined in the usual manner within the {{HTTPHeader("Report-To")}} header, for example:</p>

<pre><a href="https://wicg.github.io/reporting/#report-to" id="ref-for-report-to①">Report-To</a>: { "<a href="https://wicg.github.io/reporting/#group" id="ref-for-group①">group</a>": "nel",
             "<a href="https://wicg.github.io/reporting/#max-age" id="ref-for-max-age①">max_age</a>": 31556952,
             "<a href="https://wicg.github.io/reporting/#endpoints" id="ref-for-endpoints②">endpoints</a>": [
               { "<a href="https://wicg.github.io/reporting/#url" id="ref-for-url②">url</a>": "https://example.com/csp-reports" }
             ] }
</pre>

<h2 id="Error_reports">Error reports</h2>

<p>In these examples, the entire reporting API payload is shown. The top-level <strong><code>"body"</code></strong> key contains the network error report.</p>

<h3 id="HTTP_400_Bad_Request_response">HTTP 400 (Bad Request) response</h3>

<pre class="brush: js">{
  "age": 20,
  "type": "network-error",
  "url": "https://example.com/previous-page",
  "body": {
    "elapsed_time": 338,
    "method": "POST",
    "phase": "application",
    "protocol": "http/1.1",
    "referrer": "https://example.com/previous-page",
    "sampling_fraction": 1,
    "server_ip": "137.205.28.66",
    "status_code": 400,
    "type": "http.error",
    "url": "https://example.com/bad-request"
  }
}
</pre>

<h3 id="DNS_name_not_resolved">DNS name not resolved</h3>

<p>Note that the phase is set to <code>dns</code> in this report and no <code>server_ip</code> is available to include.</p>

<pre class="brush: js">{
  "age": 20,
  "type": "network-error",
  "url": "https://example.com/previous-page",
  "body": {
    "elapsed_time": 18,
    "method": "POST",
    "phase": "dns",
    "protocol": "http/1.1",
    "referrer": "https://example.com/previous-page",
    "sampling_fraction": 1,
    "server_ip": "",
    "status_code": 0,
    "type": "dns.name_not_resolved",
    "url": "https://example-host.com/"
  }
}
</pre>

<p>The type of the network error may be one of the following pre-defined values from the specification, but browsers can add and send their own error types:</p>

<dl>
 <dt><code>dns.unreachable</code></dt>
 <dd>The user's DNS server is unreachable</dd>
 <dt><code>dns.name_not_resolved</code></dt>
 <dd>The user's DNS server responded but was unable to resolve an IP address for the requested URI.</dd>
 <dt><code>dns.failed</code></dt>
 <dd>Request to the DNS server failed due to reasons not covered by previous errors (e.g. SERVFAIL)</dd>
 <dt><code>dns.address_changed</code></dt>
 <dd>For security reasons, if the server IP address that delivered the original report is different to the current server IP address at time of error generation, the report data will be downgraded to only include information about this problem and the type set to <code>dns.address_changed</code>.</dd>
 <dt><code>tcp.timed_out</code></dt>
 <dd>TCP connection to the server timed out</dd>
 <dt><code>tcp.closed</code></dt>
 <dd>The TCP connection was closed by the server</dd>
 <dt><code>tcp.reset</code></dt>
 <dd>The TCP connection was reset</dd>
 <dt><code>tcp.refused</code></dt>
 <dd>The TCP connection was refused by the server</dd>
 <dt><code>tcp.aborted</code></dt>
 <dd>The TCP connection was aborted</dd>
 <dt><code>tcp.address_invalid</code></dt>
 <dd>The IP address is invalid</dd>
 <dt><code>tcp.address_unreachable</code></dt>
 <dd>The IP address is unreachable</dd>
 <dt><code>tcp.failed</code></dt>
 <dd>The TCP connection failed due to reasons not covered by previous errors</dd>
 <dt><code>http.error</code></dt>
 <dd>The user agent successfully received a response, but it had a <a href="https://tools.ietf.org/html/rfc7231#section-6.5">4xx</a> or <a href="https://tools.ietf.org/html/rfc7231#section-6.6">5xx</a> status code</dd>
 <dt><code>http.protocol.error</code></dt>
 <dd>The connection was aborted due to an HTTP protocol error</dd>
 <dt><code>http.response.invalid</code></dt>
 <dd>Response is empty, has a content-length mismatch, has improper encoding, and/or other conditions that prevent user agent from processing the response</dd>
 <dt><code>http.response.redirect_loop</code></dt>
 <dd>The request was aborted due to a detected redirect loop</dd>
 <dt><code>http.failed</code></dt>
 <dd>The connection failed due to errors in HTTP protocol not covered by previous errors</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td><a href="https://w3c.github.io/network-error-logging/#introduction">Network Error Logging</a></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.NEL")}}</p>
